﻿#!/usr/bin/python
# -*- coding: utf-8 -*- 

import os
import sys
import time
import re
import urllib
import urllib2
import cookielib
import httplib


COOKIE_FILE_TMPL = ".cookies/%s/cookie.txt"
COOKIE_DIR_TMPL = ".cookies/"

DEBUG = 0
DEBUG_REPLY = 0


def main_login(cj, ljuser, ljpass):

    #
    # load main page
    #

    reqUrl = 'http://www.livejournal.com/'
    f = urllib2.urlopen(reqUrl)
    data = f.read() 
    if (DEBUG):
        print "MAIN PAGE"
        #print data


    #
    # request N1 (POST QUERY)
    #

    refererUrl = reqUrl
    reqUrl = 'https://www.livejournal.com/login.bml?ret=1'
    reqData = urllib.urlencode({'mode': 'login', 
                                'user': ljuser,
                                'password': ljpass}
                          )
    req = urllib2.Request(url=reqUrl, data=reqData)
    req.add_header('Referer', refererUrl)
    f = urllib2.urlopen(req)
    data = f.read() 

    if (DEBUG):
        print "LIVEJOURNAL ANSWER\n"
        print data

    #f = open("_login.txt", "w")
    #f.write(data)
    #f.close()

    re_getbackurl = re.compile(r'livejournal.com/logout.bml\?user=')
    m = re.search(re_getbackurl, data)
    if (m):
        print "Login success: " + ljuser
    else:
        print "Login fail, check login and pass"
        return "fail"

    return "ok"


def main_reply_one(cj, ljuser, ljpass, posturl, replytext):

    #
    # Load post
    #

    print posturl

    reqUrl = posturl
    f = urllib2.urlopen(reqUrl)
    data = f.read() 
    if (DEBUG):
        print "LOAD POST"
        print data


    f = open("_post.txt", "w")
    f.write(data)
    f.close()


    #
    # Parse lj_form_auth 
    #

    lj_form_auth = ""
    re_form_auth = re.compile(r' name="lj_form_auth" value="([^"]+)" ')
    m = re.search(re_form_auth, data)
    if (m):
        lj_form_auth = m.group(1)
        if (DEBUG_REPLY):
            print "form auth: " + lj_form_auth
    else:
        print "livejournal lj_form_auth parsing error"
        return "fail"


    #
    # Parse chrp1
    #

    chrp1 = ""
    re_form_auth = re.compile(r' name="chrp1" value="([^"]+)" ')
    m = re.search(re_form_auth, data)
    if (m):
        chrp1 = m.group(1)
        if (DEBUG_REPLY):
            print "form chrp1: " + chrp1
    else:
        print "livejournal chrp1 parsing error"
        return "fail"


    #
    # Parse chal (try1)
    #

    chal = ""
    re_form_auth = re.compile(r' name="chal" value="([^"]+)" ')
    m = re.search(re_form_auth, data)
    if (m):
        chal = m.group(1)
        if (DEBUG_REPLY):
            print "form chal: " + chal
    else:
        print "livejournal chal try1 parsing error"
        #return "fail"


    #
    # Parse chal (try2)
    #

    if (chal == ""):

        re_form_auth = re.compile(r' name=\'chal\' id=\'login_chal\' value=\'([^"]+)\' ')
        m = re.search(re_form_auth, data)
        if (m):
            chal = m.group(1)
            if (DEBUG_REPLY):
                print "form chal: " + chal
        else:
            print "livejournal chal parsing error"
            return "fail"


    #
    # Parse itemid
    #

    itemid = ""
    re_form_auth = re.compile(r' name="itemid" value="([^"]+)" ')
    m = re.search(re_form_auth, data)
    if (m):
        itemid = m.group(1)
        if (DEBUG_REPLY):
            print "form itemid: " + itemid
    else:
        print "livejournal itemid parsing error"
        return "fail"


    #
    # Parse journal
    #

    journal = ""
    re_form_auth = re.compile(r' name="journal" value="([^"]+)" ')
    m = re.search(re_form_auth, data)
    if (m):
        journal = m.group(1)
        if (DEBUG_REPLY):
            print "form journal: " + journal
    else:
        print "livejournal journal parsing error"
        return "fail"


    print "form data parsed"

    #
    # convert ljuser to lowercase and "-" to "_"
    #

    ljuser=ljuser.lower()
    ljuser=ljuser.replace("-", "_");

    #
    # request N2 (POST) replyto
    #

    refererUrl = reqUrl
    reqUrl = 'http://www.livejournal.com/talkpost_do.bml'
    reqData = urllib.urlencode({
                                    'journal': journal,
                                    'itemid': itemid,
                                    'response': "",
                                    'lj_form_auth': lj_form_auth,
                                    'chrp1': chrp1,
                                    'chal': chal,
                                    'cookieuser': ljuser,
                                    'replyto': "0",
                                    'parenttalkid': "0",
                                    'editid': "",
                                    'json': "1",
                                    'talkpost_do': "0",
                                    'subject': "",
                                    'stylemine': "0",
                                    'viewing_thread': "",
                                    'usertype': "cookieuser",
                                    'userpost': "",
                                    'password': "",
                                    'openid:url': "",
                                    'prop_picture_keyword': "",
                                    'body': replytext
                                })



    req = urllib2.Request(url=reqUrl, data=reqData)
    req.add_header('Referer', refererUrl)
    f = urllib2.urlopen(req)
    data = f.read() 

    print "form data send"

    f = open("_replyresp.txt", "w")
    f.write(data)
    f.close()

    if (DEBUG):
        print "REPLY POST ANSWER\n"
        print data


    print "Comment post reply:"
    print data.strip()


    #
    # checking return data
    # 

    re_find = re.compile(r'xdreceiver.html\?type=commentator')
    m = re.search(re_find, data)
    if (m):
        print "Now comment posted, success!"
    else:
        print "livejournal reply response error"
        return "fail"

    return "ok"


#
# Add friend
#

def main_add_friend(communityurl):

    #
    # Load users feed
    #

    reqUrl = communityurl
    f = urllib2.urlopen(reqUrl)
    data = f.read() 

    f = open("_friendfeed.txt", "w")
    f.write(data)
    f.close()

    if (DEBUG):
        print "LOAD FRIEND FEED"
        print data

    #
    # Find if we are already in members
    #

    re_getuser = re.compile(r'<p>You list ')
    m = re.search(re_getuser, data)
    if (m):
        print "Already in members"
        return "ok"


    #
    # Find community name
    #

    re_getuser = re.compile(r'"display_username":"([^"]+?)"')
    m = re.search(re_getuser, data)
    if (m):
        user = m.group(1)
        if (DEBUG):
            print "get user: " + user
    else:
        print "get user from community feed error, no community name found"
        exit(1)


    # user

    print "User/community found: " + user

    # time

    millis = int(round(time.time() * 1000))
    millis = str(millis)
    print "Local time in milliseconds: " + millis


    #
    # request N1 GET
    #

    queryData = "?user=" + user
    queryData+= "&userid=0&userpic_url="
    queryData+= "&mode=getinfo"
    queryData+= "&_=" + millis

    reqUrl = communityurl + user + '/__rpc_ctxpopup' + queryData
    print reqUrl

    req = urllib2.Request(url=reqUrl)
    req.add_header('Referer', communityurl)
    req.addheaders = [('X-Requested-With', 'XMLHttpRequest')]
    f = urllib2.urlopen(req)
    data = f.read() 
    #print data


    f = open("_ctxpopup.txt", "w")
    f.write(data)
    f.close()

    print "popup ajax loaded"

    #
    # get join group auth token
    #
    re_getfriendtoken = re.compile(r'"addFriend_authtoken":"([^"]+?)"')
    m = re.search(re_getfriendtoken, data)
    if (m):
        friend_authtoken = m.group(1)
        if (DEBUG):
            print "get friend_authtoken: " + friend_authtoken
    else:
        print "get friend_authtoken from ctx_popup error, no token found"
        exit(1)

    print "friend_authtoken found:\n" + friend_authtoken

    #
    # request N2 (POST QUERY)
    #

    reqUrl = communityurl + user + '/__rpc_changerelation'
    print reqUrl

    reqData = urllib.urlencode({'target': user, 
                                'action': 'addFriend',
                                'auth_token': friend_authtoken}
                              )
    req = urllib2.Request(url=reqUrl, data=reqData)
    req.add_header('Referer', communityurl)
    req.addheaders = [('X-Requested-With', 'XMLHttpRequest')]
    f = urllib2.urlopen(req)
    data = f.read() 


    f = open("_ctxjoin.txt", "w")
    f.write(data)
    f.close()

    if (DEBUG):
        print "JOIN COMMUNITY ANSWER\n"
        print data


    re_getbackurl = re.compile(r'"is_banned":0,"success":1,"is_member":(0|1),"is_friend":1')
    m = re.search(re_getbackurl, data)
    if (m):
        print "Join success"
    else:
        print "Join fail, check:\n" + data
        return "fail"

    print data

    return "ok"



#
# Get first N community posts
#
def main_get_community_posts(communityurl, number_post):

    reqUrl = communityurl
    f = urllib2.urlopen(reqUrl)
    data = f.read() 

    f = open("_communityfeed.txt", "w")
    f.write(data)
    f.close()

    if (DEBUG):
        print "LOAD COMMUNITY FEED"
        print data

    re_find = re.compile(r'<a href="('+communityurl+'\d+?\.html\?mode=reply)')
    plinks = re.findall(re_find, data, re.DOTALL|re.MULTILINE)

    #n_post = number_post+1
    #plinks = plinks[1:n_post]

    n_post = number_post
    plinks = plinks[0:n_post]

    for l in plinks:
        print l

    totalposts = 0
    if (plinks):
        totalposts = len(plinks)
        print "total links finded: " + str(totalposts)
    else:
        print "community posts urls parsing error"
        return "fail"

    return plinks


#
# Main process code
#
def main_process(ljuser, ljpass, community, replytext, number_post):

    #
    # make ".cookies" dir
    #

    cookies_dir = os.path.join(os.getcwd(), COOKIE_DIR_TMPL)
    if (not(os.path.exists(cookies_dir))):
        os.mkdir(cookies_dir)

    #
    # prepare request cookies
    #

    COOKIE_FILE_PATH = COOKIE_FILE_TMPL % ljuser
    cookie_file = os.path.join(os.getcwd(), COOKIE_FILE_PATH)

    cj = cookielib.CookieJar()
    cj = cookielib.MozillaCookieJar()

    if (not(os.path.exists(cookie_file))):
        if (not(os.path.exists(os.path.dirname(cookie_file)))):
            os.mkdir(os.path.dirname(cookie_file))
        cj.save(cookie_file)

    cj.load(cookie_file)
    opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
    opener.addheaders = [('User-agent', 'Mozilla/5.0')]
    urllib2.install_opener(opener)

    #
    # Login
    #

    ret = main_login(cj, ljuser, ljpass)
    if ret == "fail":
        print "Login failed"
        exit(1)
    

    #
    # Add friend
    #

    print "Add friend: " + community
    ret = main_add_friend(community)
    if (ret == "fail"):
        return "fail"

    print "Sleeping 10 sec."
    time.sleep(10)
    

    #
    # Get community first N post urls
    #

    print "Attacking community: " + community + " " + str(number_post)
    posts = main_get_community_posts(community, number_post)

    if (DEBUG):
        print posts

    #
    # Mass reply
    #

    for posturl in posts:
        #print posturl + " " + replytext
        ret = main_reply_one(cj, ljuser, ljpass, posturl, replytext)
        if ret == "ok":
            print "Reply successful"
        else:
            print "Reply failed"

    #
    # Saving state for analyze
    # 

    print "All done!"

    return


def main():
    
    community = "http://tema.livejournal.com/"

    # 
    number_post=25

    replytext = 'Ты - хуй!'

    #
    ljuser="USER1"
    ljpass="PASS1"
    main_process(ljuser, ljpass, community, replytext, number_post)

    ljuser="USER2"
    ljpass="PASS2"
    main_process(ljuser, ljpass, community, replytext, number_post)

    ljuser="USER3"
    ljpass="PASS3"
    main_process(ljuser, ljpass, community, replytext, number_post)

    ljuser="USER4"
    ljpass="PASS4"
    main_process(ljuser, ljpass, community, replytext, number_post)

    ljuser="USER5"
    ljpass="PASS5"
    main_process(ljuser, ljpass, community, replytext, number_post)


    return


if __name__ == "__main__":
    main()

